import tempfile
import shutil
from zope.testbrowser.testing import Browser
from zope.component.hooks import setSite, clearSite
from waeup.sirp.testing import FunctionalTestCase
from waeup.custom.testing import FunctionalLayer
from waeup.sirp.app import University

class CustomPackageTests(FunctionalTestCase):

    layer = FunctionalLayer

    def setUp(self):
        super(CustomPackageTests, self).setUp()

        # Setup a sample site for each test
        app = University()
        self.dc_root = tempfile.mkdtemp()
        app['datacenter'].setStoragePath(self.dc_root)

        # Put the prepopulated site into test ZODB and prepare test
        # browser
        self.getRootFolder()['app'] = app
        setSite(app)
        self.browser = Browser()
        self.browser.handleErrors = False

    def tearDown(self):
        super(CustomPackageTests, self).tearDown()
        clearSite()
        shutil.rmtree(self.dc_root)

    def test_custom_theme(self):
        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
        self.browser.open('http://localhost/app/configuration')
        self.assertMatches('...Custom Theme 1...', self.browser.contents)
        self.browser.getControl(name="form.skin").value = ['custom theme 1']
        self.browser.getControl("Save").click()
        self.browser.open('http://localhost/app/configuration')
        return